MySQL++: beemutex.h File Reference
beemutex.h File Reference

MUTually EXclusive lock class. More...

`#include "exceptions.h"`

Go to the source code of this file.

## Classes

class | mysqlpp::BeecryptMutex
| Wrapper around platform-specific mutexes. More...
class | mysqlpp::ScopedLock
| Wrapper around BeecryptMutex to add scope-bound locking and unlocking. More...

## Detailed Description

MUTually EXclusive lock class.

Author
  Bob Deblier bob.d.nosp@m.ebli.nosp@m.er@te.nosp@m.lene.nosp@m.t.be

Modified by Warren Young of Educational Technology Resources, Inc. from version in Beecrypt 4.1.2:

- minor style changes to make it fit within MySQL++
- changed init() to a ctor and destroy() to a dtor
- class just becomes a no-op if no supported mutex type is available
- throwing MutexFailed instead of `char*`
- moved all method implementations from inline in the .h file to a .cpp file so we don't have to make the header depend on config.h on autoconf-using systems
- made private mutex member a void* so we don't have to define the full type in the .h file, due to previous item
- added more Doxygen comments, and changed some existing comments
- using MAY_THROW() from MySQL++'s common.h to allow it to compile on C++17 and newer compilers